Skip to content
Get started

List tool sets

GET/v1/tool_sets

Lists all tool sets in the workspace

Query ParametersExpand Collapse
cursor: optional string

Pagination cursor from previous response

includeInfo: optional boolean

When set to true you may use more of your alloted API rate-limit

limit: optional number

Maximum number of results to return

formatint32
prefix: optional string

Filter expression (query param: prefix)

sortOrder: optional string

Sort order for results (asc or desc by creation time)

ReturnsExpand Collapse
items: optional array of ToolSet { metadata, spec, info }
metadata: ResourceMetadata { id, accountId, createdAt, 5 more }

Standard metadata for persistent, named resources (e.g., agents, tools, prompts)

id: string

Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this resource was created

formatdate-time
name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string

ID of the actor (user or service account) that created this resource

workspaceId: string

Workspace this resource belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

spec: ToolSetSpec { adapter, description }
adapter: optional ToolSetAdapter { http, mcp }
http: optional ToolSetAdapterHTTP { baseUrl, headers }
baseUrl: optional string
headers: optional map[string]
mcp: optional ToolSetAdapterMcp { excludeTools, headers, includeTools, 2 more }
excludeTools: optional McpToolFilter { operator, filters }

Top-level filter with simple boolean logic (no nesting)

operator: "OPERATOR_UNSPECIFIED" or "OPERATOR_AND" or "OPERATOR_OR"
formatenum
One of the following:
"OPERATOR_UNSPECIFIED"
"OPERATOR_AND"
"OPERATOR_OR"
filters: optional array of object { attribute, matcher }
attribute: "ATTRIBUTE_UNSPECIFIED" or "ATTRIBUTE_NAME" or "ATTRIBUTE_TITLE" or "ATTRIBUTE_DESCRIPTION"
formatenum
One of the following:
"ATTRIBUTE_UNSPECIFIED"
"ATTRIBUTE_NAME"
"ATTRIBUTE_TITLE"
"ATTRIBUTE_DESCRIPTION"
matcher: optional object { caseSensitive, contains, endsWith, 3 more }

String matching operations

caseSensitive: optional boolean
contains: optional string
endsWith: optional string
exact: optional string
regex: optional string
startsWith: optional string
headers: optional map[string]
includeTools: optional McpToolFilter { operator, filters }

Top-level filter with simple boolean logic (no nesting)

operator: "OPERATOR_UNSPECIFIED" or "OPERATOR_AND" or "OPERATOR_OR"
formatenum
One of the following:
"OPERATOR_UNSPECIFIED"
"OPERATOR_AND"
"OPERATOR_OR"
filters: optional array of object { attribute, matcher }
attribute: "ATTRIBUTE_UNSPECIFIED" or "ATTRIBUTE_NAME" or "ATTRIBUTE_TITLE" or "ATTRIBUTE_DESCRIPTION"
formatenum
One of the following:
"ATTRIBUTE_UNSPECIFIED"
"ATTRIBUTE_NAME"
"ATTRIBUTE_TITLE"
"ATTRIBUTE_DESCRIPTION"
matcher: optional object { caseSensitive, contains, endsWith, 3 more }

String matching operations

caseSensitive: optional boolean
contains: optional string
endsWith: optional string
exact: optional string
regex: optional string
startsWith: optional string
toolApprovals: optional object { always, only }

Approval filters that will automatically set the approval requirement on the tools synced from the MCP server

always: optional boolean
only: optional McpToolFilter { operator, filters }

Top-level filter with simple boolean logic (no nesting)

operator: "OPERATOR_UNSPECIFIED" or "OPERATOR_AND" or "OPERATOR_OR"
formatenum
One of the following:
"OPERATOR_UNSPECIFIED"
"OPERATOR_AND"
"OPERATOR_OR"
filters: optional array of object { attribute, matcher }
attribute: "ATTRIBUTE_UNSPECIFIED" or "ATTRIBUTE_NAME" or "ATTRIBUTE_TITLE" or "ATTRIBUTE_DESCRIPTION"
formatenum
One of the following:
"ATTRIBUTE_UNSPECIFIED"
"ATTRIBUTE_NAME"
"ATTRIBUTE_TITLE"
"ATTRIBUTE_DESCRIPTION"
matcher: optional object { caseSensitive, contains, endsWith, 3 more }

String matching operations

caseSensitive: optional boolean
contains: optional string
endsWith: optional string
exact: optional string
regex: optional string
startsWith: optional string
url: optional string
description: optional string
info: optional ToolSetInfo { agentCount, createdBy, lastSync, toolCount }

Tool set information

agentCount: optional number
createdBy: optional Profile { metadata, spec }

Profile represents a human user at the account level. Profiles are account-scoped resources that can be associated with multiple workspaces through the Actor model. Authentication for profiles is handled via SSO/OAuth (WorkOS).

metadata: AccountResourceMetadata { id, accountId, name, 3 more }

AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace.

id: string

Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string
externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

spec: ProfileSpec { type, email, name }

ProfileSpec contains the profile-specific fields

type: "PROFILE_TYPE_USER" or "PROFILE_TYPE_API_KEY" or "PROFILE_TYPE_SYSTEM"

Type is the type of profile. User's are humans, API keys are computers. You know the deal.

formatenum
One of the following:
"PROFILE_TYPE_USER"
"PROFILE_TYPE_API_KEY"
"PROFILE_TYPE_SYSTEM"
email: optional string

Email address of the user (required, unique per account)

name: optional string

Display name for the user (e.g., "Bobby Tables")

lastSync: optional string
toolCount: optional number

List tool sets

curl https://api.cadenya.com/v1/tool_sets \
    -H "Authorization: Bearer $CADENYA_API_KEY"
{
  "items": [
    {
      "metadata": {
        "id": "id",
        "accountId": "accountId",
        "createdAt": "2019-12-27T18:11:19.117Z",
        "name": "name",
        "profileId": "profileId",
        "workspaceId": "workspaceId",
        "externalId": "externalId",
        "labels": {
          "foo": "string"
        }
      },
      "spec": {
        "adapter": {
          "http": {
            "baseUrl": "baseUrl",
            "headers": {
              "foo": "string"
            }
          },
          "mcp": {
            "excludeTools": {
              "operator": "OPERATOR_UNSPECIFIED",
              "filters": [
                {
                  "attribute": "ATTRIBUTE_UNSPECIFIED",
                  "matcher": {
                    "caseSensitive": true,
                    "contains": "contains",
                    "endsWith": "endsWith",
                    "exact": "exact",
                    "regex": "regex",
                    "startsWith": "startsWith"
                  }
                }
              ]
            },
            "headers": {
              "foo": "string"
            },
            "includeTools": {
              "operator": "OPERATOR_UNSPECIFIED",
              "filters": [
                {
                  "attribute": "ATTRIBUTE_UNSPECIFIED",
                  "matcher": {
                    "caseSensitive": true,
                    "contains": "contains",
                    "endsWith": "endsWith",
                    "exact": "exact",
                    "regex": "regex",
                    "startsWith": "startsWith"
                  }
                }
              ]
            },
            "toolApprovals": {
              "always": true,
              "only": {
                "operator": "OPERATOR_UNSPECIFIED",
                "filters": [
                  {
                    "attribute": "ATTRIBUTE_UNSPECIFIED",
                    "matcher": {
                      "caseSensitive": true,
                      "contains": "contains",
                      "endsWith": "endsWith",
                      "exact": "exact",
                      "regex": "regex",
                      "startsWith": "startsWith"
                    }
                  }
                ]
              }
            },
            "url": "url"
          }
        },
        "description": "description"
      },
      "info": {
        "agentCount": 0,
        "createdBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        },
        "lastSync": "2019-12-27T18:11:19.117Z",
        "toolCount": 0
      }
    }
  ],
  "pagination": {
    "nextCursor": "nextCursor",
    "total": 0
  }
}
Returns Examples
{
  "items": [
    {
      "metadata": {
        "id": "id",
        "accountId": "accountId",
        "createdAt": "2019-12-27T18:11:19.117Z",
        "name": "name",
        "profileId": "profileId",
        "workspaceId": "workspaceId",
        "externalId": "externalId",
        "labels": {
          "foo": "string"
        }
      },
      "spec": {
        "adapter": {
          "http": {
            "baseUrl": "baseUrl",
            "headers": {
              "foo": "string"
            }
          },
          "mcp": {
            "excludeTools": {
              "operator": "OPERATOR_UNSPECIFIED",
              "filters": [
                {
                  "attribute": "ATTRIBUTE_UNSPECIFIED",
                  "matcher": {
                    "caseSensitive": true,
                    "contains": "contains",
                    "endsWith": "endsWith",
                    "exact": "exact",
                    "regex": "regex",
                    "startsWith": "startsWith"
                  }
                }
              ]
            },
            "headers": {
              "foo": "string"
            },
            "includeTools": {
              "operator": "OPERATOR_UNSPECIFIED",
              "filters": [
                {
                  "attribute": "ATTRIBUTE_UNSPECIFIED",
                  "matcher": {
                    "caseSensitive": true,
                    "contains": "contains",
                    "endsWith": "endsWith",
                    "exact": "exact",
                    "regex": "regex",
                    "startsWith": "startsWith"
                  }
                }
              ]
            },
            "toolApprovals": {
              "always": true,
              "only": {
                "operator": "OPERATOR_UNSPECIFIED",
                "filters": [
                  {
                    "attribute": "ATTRIBUTE_UNSPECIFIED",
                    "matcher": {
                      "caseSensitive": true,
                      "contains": "contains",
                      "endsWith": "endsWith",
                      "exact": "exact",
                      "regex": "regex",
                      "startsWith": "startsWith"
                    }
                  }
                ]
              }
            },
            "url": "url"
          }
        },
        "description": "description"
      },
      "info": {
        "agentCount": 0,
        "createdBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        },
        "lastSync": "2019-12-27T18:11:19.117Z",
        "toolCount": 0
      }
    }
  ],
  "pagination": {
    "nextCursor": "nextCursor",
    "total": 0
  }
}